;; This Source Code Form is subject to the terms of the Mozilla Public
;; License, v. 2.0. If a copy of the MPL was not distributed with this
;; file, You can obtain one at http://mozilla.org/MPL/2.0/.
;;
;; Copyright (c) 2019 Andrey Antukh <niwi@niwi.nz>

(ns uxbox.main.ui.colorpicker
  (:require
   [goog.object :as gobj]
   [rumext.alpha :as mf]
   [vendor.react-color]))

(mf/defc colorpicker
  [{:keys [on-change value colors] :as props}]
  (let [on-change-complete #(on-change (gobj/get % "hex"))]
    [:> js/SketchPicker {:color value
                         :disableAlpha true
                         :presetColors colors
                         :onChangeComplete on-change-complete}]))

